# Idoso+ Backend

[![pipeline status](https://tools.ages.pucrs.br/idoso-mais/idoso-mais-backend/badges/develop/pipeline.svg)](https://tools.ages.pucrs.br/idoso-mais/idoso-mais-backend/-/commits/develop)

## Instalando NodeJS

Esta aplicação é uma API desenvolvida em Node. Para conseguir rodá-la corretamente você precisa ter o NodeJS instalado na sua máquina. Para isso, vá até o site https://nodejs.org/en/ e baixe a versão LTS (a versão estável mais atualizada).

## Clonando o projeto

Tendo o node instalado, clone o projeto em uma pasta local de sua preferência através do comando `git clone https://tools.ages.pucrs.br/idoso-mais/idoso-mais-backend.git` (para isso você precisa do [git](https://git-scm.com/) instalado também).

## Extensões do VSCode

Aqui vai uma lista de extensões para se ter no VSCode e melhorar a experiência no desenvolvimento do projeto. A lista está separada por extensões obrigatórias (não ter essa extensão vai dificultar sua contribuição no projeto) e opcionais (não precisa ter, mas facilita um pouquinho a vida).

- obrigatórias:
  - editorconfig
  - eslint
  - prettier
- recomendadas
  - code spell checker
  - CodeMetrics
  - IntelliCode
  - Jest
  - NestJS Files
  - gitlens

## Rodando o ambiente de desenvolvimento

Antes de tudo você precisa criar suas variáveis de ambiente. Para isso, crie um arquivo chamado `.env.development` na raiz do projeto seguindo o modelo do `.env.template`. Preencha as informações de acordo com seus ambiente, se tiver alguma dúvida é só chamar algum colega pra checar.

Após criar o .env.development, abra um terminal na pasta do projeto e rode o comando `npm install`. Após finalizado, rode `npm run start:dev. O ambiente de desenvolvimento do Nest deve iniciar e você deve ver o log de ações que ele realizou em verde e amarelo em seu terminal.

## Checando o ambiente

Para conferir se está funcionando mesmo, acesse o link http://localhost:3000/health. Você deve receber um simples `true` na tela. Caso isso não aconteça, cheque se existe algum erro no seu console ou se há algum outro processo utilizando a porta 3000 no seu computador (se esse for o caso basta substituir a linha `PORT=3000` por qualquer outro numero no arquivo .env.development na raiz do projeto). Para testar o ambiente de desenvolvimento em ação, abra o arquivo `health.controller.ts` no editor de sua preferência e troque o `return true` para um `return false`, depois atualiza a aba do browser: ele vai trazer o resultado atualizado sem precisar fazer mais nada =)

## Rodando os testes

O NestJS por padrão gera três comando de testes possíveis de serem executados:

- `npm run test`
  - roda os testes de unidade da aplicação, os arquivos `.spec.ts`. Existe um comando alternativo `npm run test:watch` onde os testes ficam rodando a cada atualização de código, para facilitar o desenvolvimento/depuração dos testes
- `npm run test:cov`
  - extrai a cobertura dos códigos de unidade
- `npm run test:e2e`
  - roda os testes de ponta a ponta, os arquivos `e2e-spec.ts`

## Rodando o lint

O lint é uma ferramenta que checa algumas regras de convenção de código assim como formatação, para manter o padrão entre os desenvolvedores do time e manter um código consistente nesses padrões. O comando para rodar o lint é `npm run lint`.

## Banco de Dados

Utilizamos o MongoDB como banco de dados do projeto. Para rodar o setup local completo, instale o MongoDB local seguindo os passos do link https://www.mongodb.com/docs/manual/administration/install-community/ de acordo com a sua máquina. Após ter o banco instalado e rodando local, baixe o MongoDB Compass https://www.mongodb.com/docs/compass/master/install/ para acessar sua instalação local e ver o seu banco de dados local através de uma interface amigável.

Nota: a porta onde o MongoDB for instalado deve ser a porta utilizada na string de conexão `DB_CONNECTION` no arquivo .env.development da sua máquina.
