import { Injectable } from '@nestjs/common';
import * as bcrypt from 'bcrypt';
import * as dotenv from 'dotenv';

dotenv.config({ path: `.env.${process.env.NODE_ENV || 'development'}` });

@Injectable()
export class EncryptorService {
  async encrypt(password: string): Promise<string> {
    const salt = Number(process.env.SALT_VALUE)
    return await bcrypt.hash(password, salt);
  }
  async comparePassword(password:string, encryptedPassword: string): Promise<boolean>{
    return await bcrypt.compare(password, encryptedPassword);
  }
}
